/*!
  @header ECArrayIterator
  @abstract Module of Encore
 
  @availability OS X, GNUstep
  @copyright 2004, 2005, 2006 Oliver Langer

  Author: Oliver Langer

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA

  <pre>
  -------------------------------------------------------------------------
  Modification history

  04.08.05 ola     initial version
  22.08.06 ola     license changed
  -------------------------------------------------------------------------
  </pre>
*/

#include <ECArrayIterator.h>

@implementation ECArrayIterator

- initWithArray: (NSArray *) anArray {
  self = [super init];
  
  self->array = [anArray retain];
  self->currentIndex = 0;
  self->lock = [[NSLock alloc] init];
  
  return self;
}


- (void) dealloc {
  [self->array release];
  [self->lock release];
  
  [super dealloc];
}


- (BOOL) hasNext {
  return self->currentIndex < [self->array count];
}


- next {
  id toReturn = nil;
  
  [self->lock lock];
  if( self->currentIndex < [self->array count] ) {
  
    toReturn = [self->array objectAtIndex: currentIndex];
    self->currentIndex++;
    
  }
  
  [self->lock unlock];
  
  return toReturn;
}
@end
