/*!
  @header ECXMLControlContext
  @abstract Module of Encore
 
  @availability OS X, GNUstep
  @copyright 2004, 2005, 2006 Oliver Langer

  Author: Oliver Langer

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA

  <pre>
  -------------------------------------------------------------------------
  Modification history

  27.11.05 ola     initial version
  22.08.06 ola     license changed
  -------------------------------------------------------------------------
  </pre>
*/

#include <ECXMLControlContext.h>

@implementation ECXMLControlContext
- initWithState: (ECXMLControlState *) aState 
  causedEvent: (ECXMLControlEvent *) anEvent {
  
  self = [super init];
  
  self->state = [aState retain];
  self->event = [anEvent retain];
  
  return self;
}


- (void) dealloc {
  if( nil != self->state ) {
    [self->state release];
  }
  
  if( nil != self->event ) {
    [self->event release];
  }
  
  [super dealloc];
}


- (ECXMLControlEvent *) event {
  return self->event;
}


- (ECXMLControlState *) state {
  return self->state;
}
@end
